<?php

// QuickTicket 2.3 build:20091102

class cSection
{

// -- Properties --

var $domid;     // Domain id
var $domname;   // Domain name
var $id;        // Section id
var $idtitle;   // Section title
var $name;      // Section name (translation)
var $descr;     // Section descr (translation)
var $type;      // Type:   0=visible, 1=hidden, 2=hidden by user
var $status;    // Status: 0=actif,   1=closed
var $notify;    // Notify: 0=disable, 1=enabled
var $modid;     // Moderator id
var $modname;   // Moderaotr name
var $numfield;  // Format of the ref number: 'N' means no ref number
var $titlefield;// Topic title: 0=None, 1=Optional, 2=Mandatory
var $wisheddate=0;// Topic wisheddate: 0=None, 1=Optional, 2=Mandatory/none 3=Mandatory/today,4=Mandatory/day+1,5=Mandatory/day+2
var $wisheddflt=0;// Topic wisheddate [2] default: 0=None, 1=Today, 2=Day+1, 3=Day+2
var $notifycc;  // Topic alternate notify: 0=None, 1=Optional, 2=Mandatory
var $prefix;    // Prefix icon from the serie 'a'

var $stats='';   // Several stats (no used)
var $options=''; // Several options

// stats
var $topics=0;  // Total topics (including news)
var $replies=0; // Total replies (type R and F), not D
var $tags=0;    // >0 means tags exists (may be several time the same!)
var $topicsZ=0; // Total topics closed (including news)
var $repliesZ=0;// Total replies in topics closed (type R,F or  D)

// options
var $d_order='';  // Teams member default sort order (not used)
var $d_last='none'; // Last column in the topic list: 'none' means no last column
var $d_logo='';   // Section picture named s_x.gif/.jpeg/.jpg/.png (where x is the section id)

/* computed values */
var $lastpostid;
var $lastposttopic;
var $lastpostdate;
var $lastpostuser;
var $lastpostname;

// -- Constructor method (accept an id, an array or a cSection as parameter) --

function cSection($aSection=null,$bLast=false)
{
  if ( isset($aSection) )
  {
    if ( is_int($aSection) )
    {
      if ( $aSection<0 ) die('No section '.$aSection);
      global $oDB;
      $oDB->Query('SELECT * FROM '.TABSECTION.' WHERE id='.$aSection);
      $row = $oDB->Getrow();
      if ( $row===False ) die('No section '.$aSection);      
      $this->MakeFromArray($row);
    }
    elseif ( is_array($aSection) )
    {
      $this->MakeFromArray($aSection);
    }
    else
    {
      die('Invalid constructor parameter #1 for the class cSection');
    }
  }

  // Read options/stats

  $this->ReadOptions();
  $this->ReadStats();

  // Find last post
  
  if ( $bLast ) $this->GetSectionLastPost();
  
  // Default sort order and last column
  
  if ( empty($this->d_order) ) $this->d_order='lastpostdate';
  if ( $this->d_last=='wisheddate' && $this->wisheddate==0 ) $this->d_last='none';
  if ( $this->d_last=='notifiedname' && $this->notifycc==0 ) $this->d_last='none';
  if ( $this->d_last=='no' || empty($this->d_last) ) $this->d_last='none';

}

// --------

function MakeFromArray($aSection)
{
  foreach($aSection as $strKey=>$oValue) {
  switch ($strKey) {
    case 'domainid':     $this->domid     = intval($oValue); break;
    case 'id':           $this->id        = intval($oValue); break;
    case 'title':        $this->idtitle   = $oValue; break;
    case 'type':         $this->type      = intval($oValue); break;
    case 'status':       $this->status    = intval($oValue); break;
    case 'notify':       $this->notify    = intval($oValue); break;
    case 'moderator':    $this->modid     = intval($oValue); break;
    case 'moderatorname':$this->modname   = $oValue; break;
    case 'stats':        $this->stats     = $oValue; break;
    case 'options':      $this->options   = $oValue; break;
    case 'numfield':     $this->numfield  = $oValue; break;
    case 'titlefield':   $this->titlefield= intval($oValue); break;
    case 'wisheddate':
      $this->wisheddate = intval($oValue);
      if ( $this->wisheddate>2 ) { $this->wisheddflt=$this->wisheddate-2; $this->wisheddate=2;  }
      break;
    case 'alternate':    $this->notifycc  = intval($oValue); break;
    case 'prefix':       $this->prefix    = $oValue; break;
  }}
  $this->name = ObjTrans('sec','s'.$this->id,$this->idtitle);
  $this->descr = ObjTrans('secdesc','s'.$this->id,false);
  $this->domname= ObjTrans('domain','d'.$this->domid,'(domain '.$this->domid.')');
}

// --- [i] ---

function Add($intDom=0,$str='untitled')
{  
  QTargs( 'cSection->Add',array($intDom,$str),array('int','str') );
  if ( empty($str) ) die('cSection->Add: Argument #1 must be a string');

  // Inserts a new section

  global $oDB, $oVIP;
  $id = Nextid(TABSECTION);
  $oDB->Query( 'INSERT INTO '.TABSECTION.' (domainid,id,titleorder,moderator,type,status,notify,titlefield,wisheddate,alternate,title,stats,options,moderatorname,numfield,prefix) VALUES ('.$intDom.','.$id.',0,1,"0","0","0","0","0","0","'.addslashes($str).'","","coord=0;order=0;last=0;logo=0","Admin","%03s","a")' );
  
  // System

  if ( isset($_SESSION[QT]['sys_sections']) ) Unset($_SESSION[QT]['sys_sections']);
  $oVIP->Changed();
}

// ----------

function Delete()
{  
  if ( $this->id<1 ) die('cSection->Delete: Argument #1 must be an int'); // section 0 cannot be deleted

  // Process
  
  global $oDB, $oVIP;
  $this->DeleteTopics($this->id);
  $oDB->Query('DELETE FROM '.TABSECTION.' WHERE id='.$this->id);
  $oVIP->LangDel(array('sec','secdesc'),'s'.$this->id);

  // System

  if ( isset($_SESSION[QT]['sys_topics']) ) Unset($_SESSION[QT]['sys_topics']);
  if ( isset($_SESSION[QT]['sys_replies']) ) Unset($_SESSION[QT]['sys_replies']);
  if ( isset($_SESSION[QT]['sys_sections']) ) Unset($_SESSION[QT]['sys_sections']);
  $oVIP->Changed();
}

// --------

function GetSectionLastPost()
{  
  // Initialize
  
  $this->lastpostid = null;
  $this->lastposttopic = null;
  $this->lastpostdate = null;
  $this->lastpostuser = null;
  $this->lastpostname = null;
  
  // Check
  
  if ( $this->id<0 ) return null;
  if ( $this->topics==0 ) return null;

  // Query - attention: this subquery requires mysql 4.1 (use here two queries)
  
  global $oDB;
  
  $oDB->Query( 'SELECT MAX(id) as maxid FROM '.TABPOST.' WHERE forum='.$this->id );
  $row = $oDB->Getrow();
  $intId = intval($row['maxid']);
  if ( $intId>0 ) 
  {
    $oDB->Query( 'SELECT id,topic,issuedate,userid,username FROM '.TABPOST.' WHERE id='.$intId );
    if ( $row=$oDB->Getrow() )
    {
    $this->lastpostid = intval($row['id']);
    $this->lastposttopic = intval($row['topic']);
    $this->lastpostdate = $row['issuedate'];
    $this->lastpostuser = intval($row['userid']);
    $this->lastpostname = $row['username'];
    }
  }
}

// --------

function GetLogo()
{
  if ( !empty($this->d_logo) )
  {
  if ( file_exists('upload/section/'.$this->d_logo) ) return 'upload/section/'.$this->d_logo;
  }
  return $_SESSION[QT]['skin_dir'].'/ico_section_'.$this->type.'_'.$this->status.'.gif';
}

// --- [i] ---  // -1 to compute on all sections // maximum returned is $intMax distinct tags

function GetTagsUsed($intS=null,$intMax=50)
{
  // Allow instanciation
  
  if ( !isset($intS) ) $intS = $this->id;

  // Check

  if ( !is_int($intS) ) die('cSection->GetTagsUsed: Argument #1 must be integer');

  // Process

  $arrTags = array();  
  global $oDB;
  $oDB->Query( 'SELECT DISTINCT tags FROM '.TABTOPIC.($intS==-1 ? '' : ' WHERE forum='.$intS) );
  $i=0;
  while($row=$oDB->Getrow()) {
  if ( !empty($row['tags']) ) {
    $arr = explode(';',$row['tags']);
    foreach($arr as $str)
    {
      if ( !empty($str) ) {
      if ( !in_array($str,$arrTags) ) {
        $arrTags[$str] = $str;
        $i++;
        if ( $i>$intMax ) break;      
      }}
    }    
    if ( $i>$intMax ) break;
  }}
  if ( count($arrTags)>2 ) asort($arrTags);
  return $arrTags;
}

// --- [i] ---

function MoveTopics($intS=null,$intD=0,$intRenum=1,$intTopic=-1,$bClosedOnly=false,$strYear='')
{
  // Allow instanciation
  
  if ( !isset($intS) ) $intS = $this->id;

  // Check

  if ( !is_int($intS) ) die('cSection->MoveTopics: Argument #1 must be integer');
  if ( !is_int($intD) ) die('cSection->MoveTopics: Argument #2 must be integer');
  if ( $intS<0 ) die('cSection->MoveTopics: Wrong argument #1 (id<0)');
  if ( $intD<0 ) die('cSection->MoveTopics: Wrong argument #2 (d<1)');
  if ( $intS==$intD ) die('cSection->Count: Wrong argument, source=destination');
  if ( !is_string($strYear) ) $strYear = intval($strYear); // $strYear can be a integer or "old"
  if ( strlen($strYear)>4 ) die('cSection->MoveTopics: Argument #2 must be a string');

  global $oDB;

  $strWhere = (empty($strYear) ? '' : ' AND '.SqlDateCondition($strYear));
  $strTopic = '';
  $strPost = '';
  $strField = ''; if ( $intRenum==0 ) $strField = ', numid = 0';

  // if move only one topic
  if ( $intTopic>=0 )
  {
    $strTopic=" AND id=$intTopic";
    $strPost=" AND topic=$intTopic";
    if ( $intRenum==2 )
    {
    $nextnumid = Nextid(TABTOPIC,'numid','WHERE forum='.$intD);
    $strField = ', numid='.intval($nextnumid);
    }
    $bClosedOnly=false;
  }
  else
  {
    if ( $intRenum==2 )
    {
    $nextnumid = Nextid(TABTOPIC,'numid','WHERE forum='.$intD);
    $oDB->Query('SELECT MIN(numid) as minnumid FROM '.TABTOPIC.' WHERE forum='.$intS);
    $row = $oDB->Getrow();
    $minnumid = $row['minnumid'];
    $strField = ", numid = $nextnumid + (numid - $minnumid)";
    }
  }

  // check if prefix system are the same. If not, remove the prefix.
  $strSetPrefix = '';
  if ( !empty($this->prefix) )
  {
    $oDB->Query('SELECT prefix FROM '.TABSECTION.' WHERE id='.$intD);
    $row = $oDB->Getrow();
    if ( $row['prefix']!=$this->prefix ) $strSetPrefix = ',icon="00"';
  }

  // update topics and posts
  if ( $bClosedOnly )
  {
    $arr = array();
    $oDB->Query('SELECT id FROM '.TABTOPIC.' WHERE forum='.$intS.' AND status="Z" AND type="T"'.$strWhere);
    while($row=$oDB->Getrow())
    {
      $arr[] = intval($row['id']);
    }
    foreach($arr as $intKey =>$intVal)
    {
    $oDB->Query('UPDATE '.TABTOPIC." SET forum=$intD $strField WHERE id=$intVal");
    $oDB->Query('UPDATE '.TABPOST." SET forum=$intD $strSetPrefix WHERE topic=$intVal");
    }
  }
  else
  {
    $oDB->Query( 'UPDATE '.TABTOPIC." SET forum=$intD $strField WHERE forum=$intS $strTopic".$strWhere );
    $oDB->Query( 'UPDATE '.TABPOST." SET forum=$intD $strSetPrefix WHERE forum=$intS $strPost".str_replace('firstpostdate','issuedate',$strWhere) );
  }

  // Update section stats
  UpdateSectionStats($intS);
  UpdateSectionStats($intD);
}

// --- [i] ---

function DeleteTopics($s=-1,$bClosedOnly=false,$strYear='')
{
  // Check

  if ( !is_int($s) ) die('cSection->DeleteTopics: Argument #1 must be an int');
  if ( $s<0 ) die('cSection->DeleteTopics: Wrong argument #1 (id<0)');
  if ( !is_string($strYear) ) $strYear = intval($strYear); // $strYear can be a integer or the string 'old'
  if ( strlen($strYear)>4 ) die('cSection->DeleteTopics: Argument #2 must be a string');

  // Process - delete topics and posts
  
  global $oDB;

  $strWhere = (empty($strYear) ? '' : ' AND '.SqlDateCondition($strYear));

  if ( $bClosedOnly )
  {
    $arr = array();
    $oDB->Query( 'SELECT id FROM '.TABTOPIC.' WHERE forum='.$s.' AND status="Z" AND type="T"'.$strWhere );
    while($row=$oDB->Getrow())
    {
      $arr[] = $row['id'];
    }
    foreach($arr as $intKey=>$id)
    {
      $oDB->Query( 'DELETE FROM '.TABPOST.' WHERE topic='.$id );
      $oDB->Query( 'DELETE FROM '.TABTOPIC.' WHERE id='.$id );
    }
  }
  else
  {
    $oDB->Query( 'DELETE FROM '.TABPOST.' WHERE forum='.$s.str_replace('firstpostdate','issuedate',$strWhere) );
    $oDB->Query( 'DELETE FROM '.TABTOPIC.' WHERE forum='.$s.$strWhere );
    $oDB->Query( 'UPDATE '.TABSECTION.' SET topics=0, replies=0 WHERE id='.$s );
  }
  
  // Update section stats
  UpdateSectionStats($s);
}

// --- [i] ---

function Count($strObject='topics',$intS=null,$intD=10,$strYear='')
{
  // Allow instanciation

  if ( !isset($intS) ) $intS = $this->id;

  // Check

  if ( !is_int($intS) ) die('cSection->Count: Argument #2 must be an int');
  if ( !is_int($intD) ) die('cSection->Count: Argument #3 must be an int');
  if ( $intS<0 ) die('cSection->Count: Wrong argument #2 (id<0)');
  if ( $intD<1 ) die('cSection->Count: Wrong argument #3 (d<1)');
  if ( !is_string($strYear) ) $strYear = intval($strYear); // $strYear can be a integer or "old"
  if ( strlen($strYear)>4 ) die('cSection->Count: Argument #4 must be a string');

  global $oDB;
  
  $strWhere = (empty($strYear) ? '' : ' AND '.SqlDateCondition($strYear));
  
  // Process

  switch($strObject)
  {
  case 'topics': $oDB->Query('SELECT count(id) as countid FROM '.TABTOPIC.' WHERE forum='.$intS.$strWhere); break;
  case 'news': $oDB->Query('SELECT count(id) as countid FROM '.TABTOPIC.' WHERE forum='.$intS.' AND type="A"'.$strWhere); break;
  case 'closed': $oDB->Query('SELECT count(id) as countid FROM '.TABTOPIC.' WHERE status="Z" AND forum='.$intS.' AND type="T"'.$strWhere); break;
  case 'unreplied': $oDB->Query( 'SELECT count(id) as countid FROM '.TABTOPIC.' WHERE forum='.$intS.' AND replies=0 AND firstpostdate<"'.DateAdd(date('Ymd His'),-$intD,'day').'"'.$strWhere ); break;
  case 'unrepliednews': $oDB->Query( 'SELECT count(id) as countid FROM '.TABTOPIC.' WHERE forum='.$intS.' AND type="A" AND replies=0 AND firstpostdate<"'.DateAdd(date('Ymd His'),-$intD,'day').'"'.$strWhere ); break;
  default: die('cSection->Count: Wrong argument #1');
  }
  $row = $oDB->Getrow();
  return intval($row['countid']);
}

// --------

function ReadOptions()
{
  $arr = QTexplode($this->options);
  if ( isset($arr['order']) ) $this->d_order = $arr['order'];
  if ( isset($arr['last']) ) $this->d_last = $arr['last'];
  if ( isset($arr['logo']) ) $this->d_logo = $arr['logo']; 
}
function ReadStats()
{
  $arr = QTexplode($this->stats);
  if ( isset($arr['topics']) ) $this->topics = intval($arr['topics']);
  if ( isset($arr['replies']) ) $this->replies = intval($arr['replies']);
  if ( isset($arr['tags']) ) $this->tags = intval($arr['tags']);
  if ( isset($arr['topicsZ']) ) $this->topicsZ = intval($arr['topicsZ']);
  if ( isset($arr['repliesZ']) ) $this->repliesZ = intval($arr['repliesZ']);
}
function SaveOptions($arr)
{
  if ( !is_array($arr) ) die('SaveOptions: argument #1 must be an array');
  $this->options = QTimplode($arr);
  global $oDB;
  $oDB->Query('UPDATE '.TABSECTION.' SET options="'.$this->options.'" WHERE id='.$this->id);
  $this->ReadOptions(); // Refresh
}
function SaveStats($arr)
{
  if ( !is_array($arr) ) die('SaveStats: argument #1 must be an array');
  $this->stats = QTimplode($arr);
  global $oDB;
  $oDB->Query('UPDATE '.TABSECTION.' SET stats="'.$this->stats.'" WHERE id='.$this->id);
  $this->ReadStats(); // Refresh
}

// --------

}

?>