<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTicket
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.3 build:20091102
*/

session_start();
require_once('bin/qti_init.php');

$oVIP->selfurl = 'qti_index.php';

// --------
// SECURITY
// --------

if ( $_SESSION[QT]['board_offline']=='1' ) HtmlPage(99);
if ( $_SESSION[QT]['visitor_right']<1 && $oVIP->role=='V' ) HtmlPage(11);

// --------
// INITIALIZE
// --------

$arrDomains = GetDomains();

// Check for changes (-1 means reset is requested)

if ( isset($_SESSION[QT]['sys_change']) )
{
  $arr = GetParam(false,'param="sys_change"');
  if ( $_SESSION[QT]['sys_change']!=$arr['sys_change'] ) $_SESSION[QT]['sys_change']='-1';
}

// --------
// HTML START
// --------

$bJava = false;

include('qti_p_header.php');

// --------
// MY BOARD
// --------

if ( $oVIP->role!='V' && $oVIP->topics>0 )
{
  $intMytopics = 0;
  $intMyassign = 0;

  // COUNT MY TOPICS [firstpostuser]

  $oDB->Query( 'SELECT count(id) as countid FROM '.TABTOPIC.' WHERE firstpostuser='.$oVIP->id.' AND type="T" AND status<>"Z"' );
  $row = $oDB->Getrow();
  $intMytopics = intval($row['countid']);

  if ( $oVIP->IsStaff() )
  {
  $oDB->Query( 'SELECT count(id) as countid FROM '.TABTOPIC.' WHERE actorid='.$oVIP->id.' AND type="T" AND status<>"Z"' );
  $row = $oDB->Getrow();
  $intMyassign = intval($row['countid']);
  }

  // SHOW MY BUTTONS
  // ----------------
  if ( $intMytopics>0 || $intMyassign>0 ) {
  // ----------------

  echo N,'<!-- My board -->',N;
  echo '<div class="myboard">',N;
  echo '<table class="button" cellspacing="0">',N;
  echo '<tr class="button">',N;
  echo '<td><span class="myboardtitle">',$L['My_last_topic'],'</span></td>';
  if ( $intMytopics>0 )
  {
    echo '<td style="width:140px" class="button button_myboard">&nbsp;<a href="qti_search_re.php?a=user&amp;k1=',$oVIP->id,'&amp;k2=',urlencode($oVIP->username),'" class="button">',$L['All_my_topics'],'&nbsp;(',$intMytopics,')</a>&nbsp;</td>';
  }
  else
  {
    echo '<td>',$L['None'],'</td>';
  }
  if ( $oVIP->IsStaff() && $intMyassign>0 )
  {
    echo '<td style="width:5px">&nbsp;</td>';
    echo '<td style="width:140px" class="button button_myboard">&nbsp;<a href="qti_search_re.php?a=actor&amp;k1=',$oVIP->id,'&amp;k2=',urlencode($oVIP->username),'" class="button">',$L['All_my_assigned'],'&nbsp;(',$intMyassign,')</a>&nbsp;</td>';
  }
  echo '</tr>';
  echo '</table>',N;

  // MY LAST TICKET

  if ( $intMytopics>0 )
  {
    include('bin/qti_fn_sql.php');

    // User's query: tickets issued by user (for staff, tickets assigned to [lastpostuser])
    $oDB->Query( LimitSQL('t.*,p.icon,p.title,p.textmsg,f.numfield FROM (('.TABTOPIC.' t INNER JOIN '.TABPOST.' p ON t.firstpostid = p.id) INNER JOIN '.TABSECTION.' f on t.forum=f.id) WHERE t.'.($intMytopics>0 && $oVIP->IsStaff() ? 'last' : 'first').'postuser='.$oVIP->id.' AND t.type="T" AND t.status<>"Z"','t.lastpostdate DESC',0,1,1) );
    $row = $oDB->Getrow();
    if ( is_array($row) )
    {
      $oTopic = new cTopic($row);
      // find section title and reduce long titles
      if ( isset($oVIP->sections[$oTopic->section]) ) { $strSection=$oVIP->sections[$oTopic->section]; } else { $strSection='unknown section'; }
      if ( strlen($oTopic->title)>30 ) $oTopic->title=substr($oTopic->title,0,25).'...';
      if ( strlen($strSection)>30 ) $strSection=substr($strSection,0,25).'...';

      $strText = '<p style="text-align:right; margin:0" class="small"><i>'.QTdatestr($oTopic->firstpostdate,'$','$',true,true).', '.$L['I_wrote'].'</i></p><p class="small">'.$oTopic->preview.'</p>';
      $strLasttext = '';
      if ( $oTopic->firstpostid!=$oTopic->lastpostid )
      {
        $oPost = new cPost($oTopic->lastpostid);
        $strLasttext = '<p class="myboard_line small" style="text-align:right"><i>'.QTdatestr($oPost->issuedate,'$','$',true,true).', '.strtolower($L['Last_message'].' '.$L['By']).' '.$oPost->username.'</i></p><p class="small">'.QTunbbc(QTcompact($oPost->text,250,' ')).'</p>';
      }

      echo '<table class="hidden" cellspacing="0">',N;
      echo '<tr class="hidden">',N;
      if ( strtolower($oTopic->type)=='a' )
      {
        $strTicon = $_SESSION[QT]['skin_dir'].'/ico_topic_a_0.gif';
        $strTname = $L['Ico_topic_a_0'];
      }
      else
      {
        if ( isset($oVIP->statuses[$oTopic->status]['statusname']) )
        {
        $strTicon = $_SESSION[QT]['skin_dir'].'/'.$oVIP->statuses[$oTopic->status]['icon'];
        $strTname = $oVIP->statuses[$oTopic->status]['statusname'];
        }
        else
        {
        $strTicon = 'admin/ico_status.gif';
        $strTname = 'unknown status';
        }
      }
      echo '<td class="myboard">',AsImg($strTicon,'T',$strTname,'ico ico_t','','qti_topic.php?s='.$oTopic->section.'&amp;t='.$oTopic->id),( $row['numfield']=='N' ? '' : ' &middot; '.sprintf($row['numfield'],$oTopic->numid) ),' &middot; <a class="topic" href="qti_topic.php?s=',$oTopic->section,'&amp;t=',$oTopic->id,'">',$oTopic->title,'</a> &middot; <span class="small">',$L['Section'],': ',$strSection,'</span></td>',N;
      echo '</tr>',N;
      echo '<tr class="hidden">',N;
      echo '<td class="myboard">'.$strText.($strLasttext!='' ? $strLasttext : '').'</td>',N;
      echo '</tr>',N;
      echo '</table>',N;
    }
  }
  echo '</div>',N,N;
  // ----------------
  }
  // ----------------
}

// --------
// DOMAIN / SECTIONS
// --------

$intDom = 0;
$intSec = 0;
foreach($arrDomains as $intDomid=>$strDomtitle)
{

  $intDom++;
  $arrSections = GetSections($oVIP->role,$intDomid);
  if ( count($arrSections)>0 )
  {
    echo '<!-- domain ',$intDomid,': ',$strDomtitle,' -->',N;
    echo '<table class="data_s" cellspacing="0">',N;
    echo '<colgroup span="5"><col width="35"></col><col></col><col width="150"></col><col width="60"></col><col width="60"></col></colgroup>',N;
    echo '<tr class="data_s">',N;
    echo '<td class="th_s th_s_ico th_s_first">&nbsp;</td>',N;
    echo '<td class="th_s th_s_tit">',$strDomtitle,'</td>',N;
    echo '<td class="th_s th_s_inf">',$L['Last_message'],'</td>',N;
    echo '<td class="th_s th_s_sta">',$L['Topics'],'</td>',N;
    echo '<td class="th_s th_s_sta th_s_last">',$L['Replys'],'</td>',N;
    echo '</tr>',N;

    // SHOW SECTIONS

    $strAlt='r1';

    foreach($arrSections as $intSection=>$arrSection)
    {
      $intSec++;
      $oSEC = new cSection($arrSection,true);
      echo '<tr class="data_s ',$strAlt,'">',N;
      echo '<td class="td_s td_s_ico ',$strAlt,' td_s_first" >',AsImg($oSEC->GetLogo(),'S',$L['Ico_section_'.$oSEC->type.'_'.$oSEC->status],'ico ico_s','','qti_topics.php?s='.$oSEC->id),'</td>',N;
      echo '<td class="td_s td_s_tit ',$strAlt,'"><a class="section" href="qti_topics.php?s=',$oSEC->id,'" >',$oSEC->name,'</a><br/><span class="sectiondesc">',$oSEC->descr,'</span></td>',N;
      echo '<td class="td_s td_s_inf ',$strAlt,'">';
      if ( $oSEC->topics<1 )
      {
      echo S;
      }
      else
      {
        if ( isset($oSEC->lastpostid) )
        {
        echo QTdatestr($oSEC->lastpostdate,'$','$',true,true,true);
        echo ' <a href="qti_topic.php?s=',$oSEC->id,'&amp;t=',$oSEC->lastposttopic,'#p',$oSEC->lastpostid,'" title="',$L['H_Goto_message'],'">',$L['Goto_message'],'</a><br/>',strtolower($L['By']).' <a href="qti_usr.php?id=',$oSEC->lastpostuser,'" title="',$L['Ico_user_p_1'],'" class="small">',$oSEC->lastpostname,'</a>';
        }
        else
        {
        echo S;
        }
      }
      echo '</td>',N;
      echo '<td class="td_s td_s_sta ',$strAlt,'">',$oSEC->topics,'</td>',N;
      echo '<td class="td_s td_s_sta ',$strAlt,' td_s_last">',$oSEC->replies,'</td>',N;
      echo '</tr>',N;
      if ( $strAlt=='1' ) { $strAlt='2'; } else { $strAlt='1'; }
    }

    echo '<tr class="data_s">',N;
    echo '<td class="tf_s tf_s_first"></td>',N;
    echo '<td class="tf_s"></td>',N;
    echo '<td class="tf_s"></td>',N;
    echo '<td class="tf_s"></td>',N;
    echo '<td class="tf_s tf_s_last"></td>',N;
    echo '</tr>',N;

    echo '</table>',N;
    if ( $intDom<count($arrDomains) ) echo '<p class="dom_sep"></p>',N;
  }
}

// No public section

if ( $intSec==0 )
{
  echo '<p>',( $oVIP->role=='V' ? $L['E_no_public_section'] : $L['E_no_visible_section'] ),'</p>';
}

// --------
// HTML END
// --------

if ( isset($oSEC) ) unset($oSEC);
include('qti_p_footer.php');

?>