<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTicket
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.3 build:20091102
*/

session_start();
require_once('bin/qti_init.php');
if ( !$oVIP->CanView('V4') ) HtmlPage(11);
if ( !isset($_GET['y']) ) die('Missing parameter y');
include(Translate('qti_stat.php'));

include('bin/qti_fn_sql.php');

// INITIALISE

$y = intval(strip_tags($_GET['y']));
$intMonth = 0;
$s = -1;
if ( isset($_GET['m']) ) $intMonth = intval(strip_tags($_GET['m']));
if ( isset($_GET['s']) ) $s = intval(strip_tags($_GET['s']));

if ( $s>=0 )
{
$strSection = 'forum='.$s.' AND ';
$arrSectionTitle = QTarrget(GetSections('A'));
$strSectionTitle = '<br/>'.$L['Section'].' '.$arrSectionTitle[$s].'';
}
else
{
$strSection='';
$strSectionTitle = '';
}

$oVIP->selfurl = 'qti_stat.php';
$oVIP->selfname = $L['Statistics'];
$oVIP->exiturl = 'qti_stats.php';
$oVIP->exitname = '&laquo; '.$L['Statistics'];

// --------
// HTML START
// --------

$bJava = false;
$strHeadScript = '
<script type="text/javascript" src="bin/qt_jquery.js"></script>
<script type="text/javascript">
<!--
$(function() {
  $(".ajaxmouseover").mouseover(function() {
    $.post("qti_j_user.php",
      {id:this.id,lang:"'.GetLang().'",dir:"'.QTI_DIR_PIC.'"},
      function(data) { if ( data.length>0 ) document.getElementById("title_err").innerHTML=data; });
  });
});
-->
</script>
';

include('qti_p_header.php');

// USERS

if ( $intMonth==0 )
{
  if ( substr($oDB->type,0,5)=='mysql' )
  {
  $oDB->Query( 'SELECT DISTINCT userid, username, count(id) as countid FROM '.TABPOST.' WHERE '.$strSection.SqlDateCondition($y,'issuedate').' GROUP BY userid,username' );
  }
  else
  {
  $oDB->Query( 'SELECT DISTINCT userid, username FROM '.TABPOST.' WHERE '.$strSection.SqlDateCondition($y,'issuedate') );
  }
}
else
{
  if ( substr($oDB->type,0,5)=='mysql' )
  {
  $oDB->Query( 'SELECT DISTINCT userid, username, count(id) as countid FROM '.TABPOST.' WHERE '.$strSection.SqlDateCondition(($y*100+$intMonth),'issuedate',6).' GROUP BY userid,username' );
  }
  else
  {
  $oDB->Query( 'SELECT DISTINCT userid, username FROM '.TABPOST.' WHERE '.$strSection.SqlDateCondition(($y*100+$intMonth),'issuedate',6) );
  }
}
$arrUsers = array();
while($row=$oDB->Getrow())
{
  $arrUsers[$row['userid']]=$row['username'].(isset($row['countid']) ? ' ('.$row['countid'].')' : '');
}
$intUsers = count($arrUsers);
asort($arrUsers);

echo '<h1>',$L['Statistics'],'</h1>',N;

echo '<h2>',$L['Distinct_users'],( $intMonth!=0 ? ' '.$L['dateMM'][$intMonth] : ''),' ',$y,$strSectionTitle,'</h2>',N;
echo LangS('User',$intUsers).'<br/><br/>';

echo '<table class="data_t" cellspacing="0">',N;
echo '<tr class="data_t">',N;
echo '<td class="th_t th_t_inf th_t_first" style="width:10px;">&nbsp;</td>',N;
echo '<td class="th_t th_t_inf" style="width:300px">',$L['Username'],' (',strtolower($L['Messages']),')</td>',N;
echo '<td class="th_t th_t_inf" style="width:250px">',$L['Information'],'</td>',N;
echo '<td class="th_t th_t_inf th_t_last" style="width:10px;">&nbsp;</td>',N;
echo '</tr>',N;
echo '<tr class="data_t">',N;
echo '<td class="td_t td_t_inf">&nbsp;</td>',N;
echo '<td class="td_t td_t_inf" style="vertical-align:top">',N;

if ( $intUsers>0 )
{
  $str = '<br/>'; if ($intUsers>50) $str = ', ';
  foreach($arrUsers as $intId=>$strName)
  {
  echo '<a class="ajaxmouseover" id="u',$intId,'" href="qti_usr.php?id=',$intId,'">',$strName,'</a>',$str;
  }
}
else
{
  echo $L['None'].'<br/>';
}

echo '</td>',N;
echo '<td class="td_t td_t_inf" style="vertical-align:top">',N;

  // DISPLAY Preview
  echo '<script type="text/javascript"></script><noscript>Your browser does not support JavaScript</noscript>';
  echo '<div id="title_err"></div>',N;

// preview
echo '</td>
<td class="td_t td_t_inf">&nbsp;</td>
</tr>
<tr class="data_t">
<td class="tf_t tf_t_first"></td>
<td class="tf_t"></td>
<td class="tf_t"></td>
<td class="tf_t tf_t_last"></td>
</tr>
</table>
';

// HTML END

echo '<p><a href="',$oVIP->exiturl,'">',$oVIP->exitname,'</a></p>',N;

include('qti_p_footer.php');

?>