<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTicket
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.3 build:20091102
*/

session_start();
require_once('bin/qti_init.php');
if ( !$oVIP->CanView('V0') ) HtmlPage(11);

// INITIALISE

include(GetLang().'qti_reg.php');

$oVIP->selfurl = 'qti_usr_new.php';
$oVIP->selfname = $L['Register'];

// --------
// EXECUTE FORM
// --------

if ( isset($_POST['ok']) )
{
  if ( !isset($_POST['agreed']) )
  {
    $bJava = false;
    include('qti_p_header.php');
    HtmlMsg(0,'370px','login_header',$oVIP->selfname,'login');
    $strFile=GetLang().'sys_not_agree.txt';
    if ( file_exists($strFile) ) { include($strFile); } else { echo 'Rules not agreed...'; }
    echo '<p><a href="',$oVIP->selfurl,'">',$L['Register'],'</a></p>';
    HtmlMsg(1);
    include('qti_p_footer.php');
    Exit;
  }

  // continue to registration form
  if ( headers_sent() )
  {
  echo '<a id="exiturl" href="qti_form_reg.php',(QTI_USE_COPPA ? '?c='.$_POST['child'] : ''),'">',$L['Register'],'</a><meta http-equiv="REFRESH" content="0;url=qti_form_reg.php',(QTI_USE_COPPA ? '?c='.$_POST['child'] : ''),'">';
  }
  else
  {
  header('Location: qti_form_reg.php'.(QTI_USE_COPPA ? '?c='.$_POST['child'] : ''));
  }
  Exit;
}

// --------
// HTML START
// --------

$oVIP->css[] = 'qti_main2.css';

include('qti_p_header.php');

echo '
<div class="scrollmessage">
';

$strFile = GetLang().'sys_rules.txt';
if ( file_exists($strFile) ) { include($strFile); } else { echo "Missing file:<br/>$strFile"; }

echo '
</div>
';

echo '
<form method="post" action="',$oVIP->selfurl,'"><p><input type="checkbox" id="agreed" name="agreed"/> <label for="agreed"><b>&nbsp;',$L['Agree'],'</b></label></p>
';
HtmlMsg(0,'300px','login_header',$oVIP->selfname,'login');
echo '<p>';
if ( QTI_USE_COPPA )
{
echo '<input type="radio" id="child1" name="child" value="2" checked="checked"/><label for="child1">',$L['I_am_child'],'</label><br/>',N;
echo '<input type="radio" id="child0" name="child" value="0"/><label for="child0">',$L['I_am_not_child'],'</label><br/>',N;
}
else
{
echo $L['Proceed'];
}
echo '</p><p><input type="submit" name="ok" value="',$L['Ok'],'"/></p>';
HtmlMsg(1);
echo'
</form>
';

// HTML END

include('qti_p_footer.php');

?>